import { PrismaClient } from '@prisma/client'
import { SlashCommand, SlashCreator, CommandContext } from 'slash-create'

export default class LeaderboardCommand extends SlashCommand {
  constructor(creator: SlashCreator) {
    super(creator, {
      name: 'leaderboard',
      description: 'see top 10 messages'
    })
  }

  async run(ctx: CommandContext) {
    const prisma = new PrismaClient()
    const users = await prisma.user.findMany({
      where: { guild_id: ctx.guildID },
      take: 10,
      orderBy: { messages: 'desc' }
    })
    let st = ''
    for (const u of users) {
      st += `<@${u.id}> - ${u.messages} message(s)\n`
    }
    ctx.send(st, {allowedMentions: {everyone: false, roles: false, users: false}})
  }
}
